//DualUzi.cs

//we'll only get this far if we actually have the uzi add-on
//  so it's safe to directly use stuff from that
//AddDamageType(<name>, <suicide message>, <kill message>, <vehicle damage scale>, <is direct damage>);
AddDamageType("DualUzi",   '<bitmap:add-ons/Weapon_DualUzi/CI_DualUzi> %1',    '%2 <bitmap:add-ons/Weapon_DualUzi/CI_DualUzi> %1',0.05,1);
datablock ProjectileData(DualUziProjectile)
{
   projectileShapeName = "add-ons/Weapon_Uzi/Uzibullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::DualUzi;
   radiusDamageType    = $DamageType::DualUzi;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Akimbo Gun Bullet";
};

//////////
// item //
//////////
datablock ItemData(DualUziItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Weapon_Uzi/Uzi.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Dual Uzis";
	iconName = "./Icon_DualUzi";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = DualUziImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DualUziImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Uzi/Uzi.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DualUziProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = DualUziItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Fire2";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.07;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = UziShot1Sound;
   stateEmitter[2]					= UziSmokeEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Fire2";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Fire3";
   stateWaitForTimeout[3] = true;
	stateTimeoutValue[3] = 0.07;
	stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = UziShot1Sound;
   stateEmitter[3]					= UziSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";

	stateName[4] = "Fire3";
	stateEjectShell[4]       = true;
	stateSequence[4] = "Fire";
	stateTransitionOnTimeout[4] = "Fire4";
   stateWaitForTimeout[4] = true;
	stateTimeoutValue[4] = 0.07;
	stateFire[4] = true;
	stateAllowImageChange[4] = false;
	stateScript[4] = "onFire";
	stateSound[4] = UziShot1Sound;
   stateEmitter[4]					= UziSmokeEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";

	stateName[5] = "Fire4";
	stateEjectShell[5]       = true;
	stateSequence[5] = "Fire";
	stateTransitionOnTimeout[5] = "Fire5";
   stateWaitForTimeout[5] = true;
	stateTimeoutValue[5] = 0.07;
	stateFire[5] = true;
	stateAllowImageChange[5] = false;
	stateScript[5] = "onFire";
	stateSound[5] = UziShot1Sound;
   stateEmitter[5]					= UziSmokeEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";

	stateName[6] = "Fire5";
	stateEjectShell[6]       = true;
	stateSequence[6] = "Fire";
	stateTransitionOnTimeout[6] = "Smoke";
   stateWaitForTimeout[6] = true;
	stateTimeoutValue[6] = 0.09;
	stateFire[6] = true;
	stateAllowImageChange[6] = false;
	stateScript[6] = "onFire";
	stateSound[6] = UziShot1Sound;
   stateEmitter[6]					= UziSmokeEmitter;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";

   stateName[7] = "Smoke";
	stateEmitter[7]					= gunSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzleNode";
	stateTimeoutValue[7]            = 0.01;
	stateTransitionOnTimeout[7]     = "Reload";

	stateName[8] = "Reload";
	stateAllowImageChange[8] = false;
	stateTransitionOnTriggerUp[8] = "FireLeftUzi";
	stateSequence[8] = "ready";

	stateName[9] = "FireLeftUzi";
	stateTimeoutValue[9] = 0.07;
	stateScript[9] = "onFireLeftUzi";
	stateTransitionOnTimeOut[9] = "Ready";


};


function DualUziImage::onFireLeftUzi(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}


datablock ShapeBaseImageData(LeftUziImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Uzi/Uzi.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DualUziProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = true;
   colorShiftColor = DualUziItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";
   stateSound[0]		= weaponSwitchSound;

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Fire2";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.07;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = UziShot1Sound;
   stateEmitter[2]					= UziFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Fire2";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Fire3";
   stateWaitForTimeout[3] = true;
	stateTimeoutValue[3] = 0.07;
	stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = UziShot1Sound;
   stateEmitter[3]					= UziFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";

	stateName[4] = "Fire3";
	stateEjectShell[4]       = true;
	stateSequence[4] = "Fire";
	stateTransitionOnTimeout[4] = "Fire4";
   stateWaitForTimeout[4] = true;
	stateTimeoutValue[4] = 0.07;
	stateFire[4] = true;
	stateAllowImageChange[4] = false;
	stateScript[4] = "onFire";
	stateSound[4] = UziShot1Sound;
   stateEmitter[4]					= UziFlashEmitter;
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";

	stateName[5] = "Fire4";
	stateEjectShell[5]       = true;
	stateSequence[5] = "Fire";
	stateTransitionOnTimeout[5] = "Fire5";
   stateWaitForTimeout[5] = true;
	stateTimeoutValue[5] = 0.07;
	stateFire[5] = true;
	stateAllowImageChange[5] = false;
	stateScript[5] = "onFire";
	stateSound[5] = UziShot1Sound;
   stateEmitter[5]					= UziFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";

	stateName[6] = "Fire5";
	stateEjectShell[6]       = true;
	stateSequence[6] = "Fire";
	stateTransitionOnTimeout[6] = "Smoke";
   stateWaitForTimeout[6] = true;
	stateTimeoutValue[6] = 0.09;
	stateFire[6] = true;
	stateAllowImageChange[6] = false;
	stateScript[6] = "onFire";
	stateSound[6] = UziShot1Sound;
   stateEmitter[6]					= UziFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";

   stateName[7] = "Smoke";
	stateEmitter[7]					= UziSmokeEmitter;
	stateEmitterTime[7]				= 0.05;
	stateEmitterNode[7]				= "muzzleNode";
	stateTimeoutValue[7]            = 0.01;
	stateTransitionOnTimeout[7]     = "Reload";

	stateName[8] = "Reload";
	stateAllowImageChange[8] = false;
	stateTransitionOnTriggerUp[8] = "Ready";
	stateSequence[8] = "ready";


};

function LeftUziImage::onFire(%this, %obj, %slot)
{
   Parent::onFire(%this,%obj,%slot);
   if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, leftrecoil);
}

function DualUziImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount left uzi
   %obj.mountImage(LeftUziImage, 1);
   //%obj.playThread(0, armreadyboth);
}
function DualUziImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount left uzi
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}


function LeftUziImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function LeftUziImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}

function DualUziImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	

   //%obj.setImageTrigger(1,1);
}